## AS the villager
# This is the main function for displaying chat output
# main (player: UUID, villager: UUID)

## 1. Display name and health (block #1)
# 1.1.1 Store current health and halve it, so it can be read as amount-of-hearts
execute store result storage villager_stats:temp data.health int 0.5 run data get entity @s Health
# 1.1.1 Store max health and halve it, so it can be read as amount-of-hearts
execute store result storage villager_stats:temp data.health_max int 0.5 run attribute @s generic.max_health base get
# 1.2a Version displaying the Villager's CustomName
$execute if data entity @s CustomName as $(player) run tellraw @s ["",{"text":"\nStats for ["},{"nbt":"CustomName","entity":"$(villager)","interpret": true,"color":"green"},{"text":"] "},{"text":"(","color":"dark_gray"},{"nbt":"data.health","storage":"villager_stats:temp","color":"red"},{"text":"/","color":"gray"},{"nbt":"data.health_max","storage":"villager_stats:temp","color":"red"},{"text":"\u2764","color":"dark_red"},{"text":")\n","color":"dark_gray"}]
# 1.2b Version displaying 'Villager' in the player's language
$execute unless data entity @s CustomName as $(player) run tellraw @s ["",{"text":"\nStats for ["},{"translate": "entity.minecraft.villager"},{"text":"] "},{"text":"(","color":"dark_gray"},{"nbt":"data.health","storage":"villager_stats:temp","color":"red"},{"text":"/","color":"gray"},{"nbt":"data.health_max","storage":"villager_stats:temp","color":"red"},{"text":"\u2764","color":"dark_red"},{"text":")\n","color":"dark_gray"}]

## 2. Display information for adult / baby villager (block #2)
# 2.1 Adult
execute if entity @s[nbt={Age:0}] run function villager_stats:impl/display/adult_villager with storage villager_stats:temp data
# 2.2 Baby
execute unless entity @s[nbt={Age:0}] run function villager_stats:impl/display/baby_villager with storage villager_stats:temp data
# 2.3 New line
$execute as $(player) run tellraw @s {"text":""}

## 3. Display home & job site locations (block #3)
# 3.1 Reset counter
scoreboard players set locations villager_stats.temp 0
# 3.2 Display home location
data modify storage villager_stats:temp data merge value {prefix:"  Home: ", location:"minecraft:home", type: 2}
execute if data entity @s Brain.memories."minecraft:home" run function villager_stats:impl/display/villager_location with storage villager_stats:temp data
# 3.3 Display workstation location
data modify storage villager_stats:temp data merge value {prefix:"  Job site: ", location:"minecraft:job_site", type: 1}
execute if data entity @s Brain.memories."minecraft:job_site" run function villager_stats:impl/display/villager_location with storage villager_stats:temp data
# 3.4 Display new line, if any location was displayed
$execute unless score locations villager_stats.temp matches 0 as $(player) run tellraw @s {"text":""}

## 4. Display inventory contents (block #4)
# 4.0 Header
$execute as $(player) run tellraw @s {"text":"  Inventory contents:"}
# 4.1.1 Check amount of entries in the Inventory NBT property
execute store result score @s villager_stats.loop.max run data get entity @s Inventory
# 4.1.1 Reset loop / iteration variable
scoreboard players set @s villager_stats.loop.i 0
# 4.2 Handle inventory being empty or not empty
# 4.2.1a If it's not empty: start iterating over item entries and display them in chat
execute unless score @s villager_stats.loop.max matches 0 run function villager_stats:impl/iterate
# 4.2.1a If it's empty: Display a message stating that the inventory is emtpy
$execute if score @s villager_stats.loop.max matches 0 run execute as $(player) run tellraw @s {"text": "\u0020 \u0020 (None)","italic": true,"color": "gray"}

## 5. Empty line at the end
$execute as $(player) run tellraw @s {"text": ""}
